﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsAppUP02._02Alekseev2
{
    /// <summary>
    /// Класс FormMain, в котором реализована функция расчета ответа для переменной t, реализована кнопка, при нажатии на которую происходит расчет ответа
    /// </summary>
    public partial class FormMain : Form
    {
        /// <summary>
        /// Метод, в котором происходит загрузка компонентов формы
        /// </summary>
        public FormMain()
        {
            InitializeComponent();
        }

        /// <summary>
        /// Метод, в котором при загрузке формы меняется цвет фона, а также подставляются значения в TextBox
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Form1Load(object sender, EventArgs e)
        {
            BackColor = Color.AntiqueWhite;
            txtValueX.Text = "14,26";
            txtValueY.Text = "-1,22";
            txtValueZ.Text = "0,035";
        }

        /// <summary>
        /// Метод кнопки, при нажатии на которую в TextBox подставляются записи и происходит расчет ответа 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        public void btnResultValueClick(object sender, EventArgs e)
        {
            double X = double.Parse(txtValueX.Text);
            txtValueX.Text += Environment.NewLine + " - Значение X";            
            double Y = double.Parse(txtValueY.Text);
            txtValueY.Text += Environment.NewLine + " - Значение Y";
            double Z = double.Parse(txtValueZ.Text);
            txtValueZ.Text += Environment.NewLine + " - Значение Z";

            double t = 2 * Math.Cos(X - (Math.PI / 6)) / (0.5 + (Math.Pow(Math.Sin(Y), 2)) * 1 + (Math.Pow(Z, 2)) / (3 - (Math.Pow(Z, 2)) / 5));
               
            txtValueT.Text += Environment.NewLine + "Результат t = " + Math.Round(t, 6).ToString();
        }

        /// <summary>
        /// Метод, предназначенный для unit-теста
        /// </summary>
        /// <param name="X">Переменная X, используемая в вычислениях примера. Ее значение - 14,26 </param>
        /// <param name="Y">Переменная Y, используемая в вычислениях примера. Ее значение - -1,22 </param>
        /// <param name="Z">Переменная Z, используемая в вычислениях примера. Ее значение - 0.035 </param>
        /// <returns></returns>
        public double btnResultValueClickTest(double X, double Y, double Z)
        {
            double t = 2 * Math.Cos(X - (Math.PI / 6)) / (0.5 + (Math.Pow(Math.Sin(Y), 2)) * 1 + (Math.Pow(Z, 2)) / (3 - (Math.Pow(Z, 2)) / 5));
            t = Math.Round(t, 6);
            txtValueT.Text += Environment.NewLine + "Результат t = " + t.ToString();
            return t;
        }
    }
}
